package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.common.util.json.JsonUtils;
import cn.iocoder.yudao.module.delivery.entity.*;
import cn.iocoder.yudao.module.delivery.entity.bar.CustomerReportBar;
import cn.iocoder.yudao.module.delivery.entity.bar.series;
import cn.iocoder.yudao.module.delivery.entity.bar.yAxis;
import cn.iocoder.yudao.module.delivery.mapper.EmployeeMapper;
import cn.iocoder.yudao.module.delivery.mapper.SalesReportMapper;
import cn.iocoder.yudao.module.delivery.service.SalesReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/*
  销售看板统计报表
  lanbm 2024-04-01 add
 */
@Service("SalesReportService")
public class SalesReportImpl implements SalesReportService {

    @Autowired
    private SalesReportMapper salesReportMapper;

    public SalesReportResp SalesReportCount(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);
        SalesReportResp Resp = salesReportMapper.SalesReportCount(ReqCur);
        //总值
        if (Resp.getCurValue() == null ||
                Resp.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setCurValue(new BigDecimal(0));
        }

        //同比值
        if (Resp.getTbValue() == null ||
                Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setTbValue(new BigDecimal(0));
        }

        //环比值
        if (Resp.getHbValue() == null ||
                Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setHbValue(new BigDecimal(0));
        }

        //计算同比
        String sTemp = "";
        if (Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getTbValue()),
                    Resp.getTbValue());
        }
        Resp.setTbShow(sTemp);


        //计算环比
        if (Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "上期期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getHbValue()),
                    Resp.getHbValue());
        }
        return Resp;
    }

    /*
    海运统计
    */
    public SalesReportResp SalesReportCountSea(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        SalesReportResp Resp = salesReportMapper.SalesReportCountSea(Req);

        if (Resp.getCurValue() == null ||
                Resp.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setCurValue(new BigDecimal(0));
        }

        //同比值
        if (Resp.getTbValue() == null ||
                Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setTbValue(new BigDecimal(0));
        }

        //环比值
        if (Resp.getHbValue() == null ||
                Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setHbValue(new BigDecimal(0));
        }

        //计算同比
        String sTemp = "";
        if (Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getTbValue()),
                    Resp.getTbValue());
        }
        Resp.setTbShow(sTemp);


        //计算环比
        if (Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "上期期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getHbValue()),
                    Resp.getHbValue());
        }
        return Resp;
    }


    /*
     空运统计
     */
    public SalesReportResp SalesReportCountAir(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        SalesReportResp Resp = salesReportMapper.SalesReportCountAir(Req);

        //当期值
        if (Resp.getCurValue() == null ||
                Resp.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setCurValue(new BigDecimal(0));
        }

        //同比值
        if (Resp.getTbValue() == null ||
                Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setTbValue(new BigDecimal(0));
        }

        //环比值
        if (Resp.getHbValue() == null ||
                Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setHbValue(new BigDecimal(0));
        }

        //计算同比
        String sTemp = "";
        if (Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getTbValue()),
                    Resp.getTbValue());
        }
        Resp.setTbShow(sTemp);


        //计算环比
        if (Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "上期期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getHbValue()),
                    Resp.getHbValue());
        }

        Resp.setHbShow(sTemp);

        return Resp;
    }

    /*
     获取首次成交统计数据 lanbm 2024-05-09 add
     */
    public SalesReportCusTarget FirstCustomerCount(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        SalesReportCusTarget objResult = new SalesReportCusTarget();
        int nR = salesReportMapper.FirstCustomerCount(ReqCur);
        int nRTb = salesReportMapper.FirstCustomerCount(ReqLast);
        String sTemp = "";
        if (nRTb == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(new BigDecimal(nR - nRTb), new BigDecimal(nRTb));
        }
        objResult.setTbShow(sTemp);
        return objResult;
    }

    /*
     根据查询参数获取同比查询参数 lanbm 2024-05-09 add
     */
    private SalesReportReq getReqTb(SalesReportReq Req) {
        SalesReportReq ReqLast = new SalesReportReq();
        ReqLast.setSDate(Req.getSDuiBiDate());
        ReqLast.setEDate(Req.getEDuiBiDate());
        ReqLast.setCurYear(Req.getDuibiYear());
        ReqLast.setDeptid(Req.getDeptid());
        ReqLast.setSalesmanid(Req.getSalesmanid());
        return ReqLast;
    }


    /*
    统计一段时间内客户成交数目，出重客户
    lanbm 2024-05-09 add
    */
    public SalesReportCusTarget CustomerTargetCount(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        SalesReportCusTarget objResult = new SalesReportCusTarget();
        int nR = salesReportMapper.CustomerTargetCount(Req);
        int nRTb = salesReportMapper.CustomerTargetCount(ReqLast);
        String sTemp = "";
        if (nRTb == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(new BigDecimal(nR - nRTb), new BigDecimal(nRTb));
        }
        objResult.setTbShow(sTemp);
        return objResult;
    }

    /*
   格式化BigDecimal为字符串，保留两位小数
   lanbm 2024-04-10 add
   */
    private String format(BigDecimal value) {
        NumberFormat numberFormat = NumberFormat.getInstance();
        numberFormat.setMinimumFractionDigits(2);
        numberFormat.setMaximumFractionDigits(2);
        return numberFormat.format(value.doubleValue());
    }

    /*
    计算百分比
    lanbm 2024-04-10 add
    */
    private String getPercentage(BigDecimal part, BigDecimal total) {
        BigDecimal percentage = part.divide(total, 5,
                BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100"));
        // 输出百分比
        String sR = format(percentage) + "%";
        return sR;
    }

    private String getCurDate() {
        Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String currentDate = sdf.format(date);
        return currentDate;
    }

    private int getCurYear() {
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);
        return year;
    }

    /*
     获取某年某月的最后一天 lanbm 2024-04-16 add
     */
    private int getLastDay(int year, int month) {
        YearMonth yearMonth = YearMonth.of(year, month);
        int lastDay = yearMonth.lengthOfMonth();
        return lastDay;
    }

    /*
     对查询日期做初始化处理 lanbm 2024-05-09 add
     */
    private SalesReportReq getReq(SalesReportReq Req) throws ParseException {
        int y = getCurYear();
        if (Req.getDuibiYear() == null) {
            Req.setDuibiYear(String.valueOf(y - 1));
        }

        if (Req.getSDate() == null) {
            Req.setCurYear(String.valueOf(y));
            Req.setSDate(String.valueOf(y) + "-01-01");
            Req.setSDuiBiDate(Req.getDuibiYear() + "-01-01");

        } else {
            //2024-03
            String sT = Req.getSDate();
            Req.setSDate(sT + "-01");

            String s = sT.substring(5, 7);
            Req.setSDuiBiDate(Req.getDuibiYear() + "-" + s + "-01");

            Req.setCurYear(sT.substring(0, 4));
        }

        if (Req.getEDate() == null) {
            Req.setEDate(getCurDate());

            String s = Req.getEDate().substring(5, 7);
            int lastDay = getLastDay(Integer.parseInt(Req.getDuibiYear()), Integer.parseInt(s));
            Req.setEDuiBiDate(Req.getDuibiYear() + "-" + s + "-" + String.valueOf(lastDay));

        } else {
            String sE = Req.getEDate();
            String sY = sE.substring(0, 4);
            String s = sE.substring(5, 7);
            int lastDay = getLastDay(Integer.parseInt(sY), Integer.parseInt(s));
            Req.setEDate(sE + "-" + String.valueOf(lastDay));

            lastDay = getLastDay(Integer.parseInt(Req.getDuibiYear()), Integer.parseInt(s));
            Req.setEDuiBiDate(Req.getDuibiYear() + "-" + s + "-" + String.valueOf(lastDay));
        }
        //计算月份差
        long lc = monthDiff(Req.getSDate(), Req.getEDate());
        if (lc == 0) {
            lc = 1;
        }


        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date date1 = format.parse(Req.getSDate());
        Date date2 = format.parse(Req.getEDate());

        Req.setDS(date1);
        Req.setDE(date2);
        Req.setSumMonth(lc);

        return Req;
    }

    private int monthDiff(String dateString1, String dateString2) {
        // 将字符串转换为 LocalDate 对象
        LocalDate date1 = LocalDate.parse(dateString1);
        LocalDate date2 = LocalDate.parse(dateString2);

        // 获软时间1的年份和月份
        int year1 = date1.getYear();
        int month1 = date1.getMonthValue();
        // 获取时间2的年份和月份
        int year2 = date2.getYear();
        int month2 = date2.getMonthValue();

        // 计算时间1的总月数
        int totalMonths1 = year1 * 12 + month1;
        // 计算时间2的总月数
        int totalMonths2 = year2 * 12 + month2;
        // 计算总月数差
        int monthsDiff = totalMonths2 - totalMonths1;

        return monthsDiff;
    }

    public CustomerReportBar getCustomerReportBar(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        CustomerReportBar customerReportBar = new CustomerReportBar();

        yAxis y = new yAxis();
        List<String> l = new ArrayList<>();
        //日期格式化
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date tmp = Req.getDS();
        Calendar dd = Calendar.getInstance();
        dd.setTime(Req.getDS());
        while (tmp.getTime() < Req.getDE().getTime()) {
            String s = sdf.format(tmp).substring(0, 7);
            l.add(s);
            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();
        }
        y.setData(l);
        customerReportBar.setObjyAxis(y);

        List<series> sl = new ArrayList<>();

        //总V值
        series s1 = new series();
        List<String> s1L = new ArrayList<>();
        //循环按月份统计数据
        dd.setTime(Req.getDS());
        tmp = Req.getDS();
        while (tmp.getTime() < Req.getDE().getTime()) {
            //月份开始日期
            String s = sdf.format(tmp);

            SalesReportResp r= salesReportMapper.SalesReportCount(Req);
            s1L.add(r.getCurValue().toString());
            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();
        }
        s1.setData(s1L);
        sl.add(s1);

        //海运
        series s2 = new series();
        List<String> s2L = new ArrayList<>();
        dd.setTime(Req.getDS());
        tmp = Req.getDS();
        while (tmp.getTime() < Req.getDE().getTime()) {
            String s = sdf.format(tmp);

            SalesReportResp r= salesReportMapper.SalesReportCountSea(Req);
            s2L.add(r.getCurValue().toString());

            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();
        }
        s2.setData(s2L);
        sl.add(s2);

        //空运
        series s3 = new series();
        List<String> s3L = new ArrayList<>();
        dd.setTime(Req.getDS());
        tmp = Req.getDS();
        while (tmp.getTime() < Req.getDE().getTime()) {
            String s = sdf.format(tmp);

            SalesReportResp r= salesReportMapper.SalesReportCountAir(Req);
            s3L.add(r.getCurValue().toString());

            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();
        }
        s3.setData(s3L);
        sl.add(s3);

        customerReportBar.setObSseries(sl);
        return customerReportBar;

    }

}
